/*

  Copyright (C) 2020 willipink.eu
  Author Moritz Münch moritzmuench@mailbox.org

  This program is free software: you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation, either version 3 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program. If not, see <http://www.gnu.org/licenses/>. */


import { Cookie } from './modules/cookie.mjs';


$(document).ready(function() {


  function render_login(name, color) {
    // manage user login

    new Cookie('coinc-name', name)
    $('label#for_select_usernames').html('Wilkommen zurück');
    render_login_color(color);
    let option = $('div.username option[value=' + name + ']');

    if (!option) {
      $('div.username select').append($('<option>', { value: name, html: name }));
    }

    $('div.username option[value=' + name + ']').attr('selected', 'selected');
  }


  function render_login_color(color) {
    // manage login colors

    $('div.username').css('background-color', color);
    new Cookie('coinc-color', color);
  }


  $('div.username select').on('change', function() {

    color = $('div.username option[value=' + this.value + ']').attr('label');
    render_login(this.value, color);
  });


  $('button#show_add_user').click(function() {

    $('div#modal_add_user').show('fast');
    $('button#close_modal_add_user').click(function() {

      $('div#modal_add_user').hide('fast'); }); });


  $('button#add_user').click(function() {

    let name = $('input#text_user').val();
    let color = $('input#text_color').val();

    $.ajax({
      type: 'GET',
      dataType: 'json',
      url: 'add/user/' + name + '/color/' + color,
      success: function(response) {

        if (response.error) {
          $('span#response').html(response.message);
          $('span#response').css('color', 'red');

        } else {
          $('span#response').css('color', 'black');
          $('div#modal_add_user').hide('fast');
          $('span#user_message').hide();
          render_login(name, color);
        }
      }
    });
  });


  let cookie = new Cookie();
  let name = cookie.get('coinc-name');
  let color = cookie.get('coinc-color');

  if (name != '') {
    render_login(name, color);
  }
});
